#include "config_private.h"
#include "types.h"
#include "wtruntime.h"

const char* wtrMnError(wt_error err)
{
	switch(err)
	{
	case WTE_OK:     return "OK";
	case WTE_BADARG: return "BADARG";
	case WTE_LFAIL:  return "LFAIL";
	case WTE_NOENT:  return "NOENT";
	case WTE_NOMEM:  return "NOMEM";
	case WTE_NOFIT:  return "NOFIT";
	case WTE_DUPENT: return "DUPENT";
	case WTE_REFER:  return "REFER";
	case WTE_BINERR: return "BINERR";
	case WTE_BADVER: return "BADVER";
	case WTE_UNRES:  return "UNRES";
	case WTE_AMBIG:  return "AMBIG";
	case WTE_BADEX:  return "BADEX";
	case WTE_URTEX:  return "URTEX";
	case WTE_INVOKE: return "INVOKE";
	case WTE_INTEG:  return "INTEG";
	case WTE_MEMSZ:  return "MEMSZ";
	case WTE_REFCTX: return "REFCTX";
	case WTE_BADCTX: return "BADCTX";
	case WTE_NOSTK:  return "NOSTK";
	case WTE_DESTRP: return "DESTRP";
	case WTE_UCLEAN: return "UCLEAN";
	default:         return NULL;
	}
}

const char* wtrStrError(wt_error err)
{
	switch(err)
	{
	case WTE_OK:     return "Success";
	case WTE_BADARG: return "Bad argument";
	case WTE_LFAIL:  return "Low-level or system-wide failure";
	case WTE_NOENT:  return "No such entity";
	case WTE_NOMEM:  return "Not enough memory";
	case WTE_NOFIT:  return "Data does not for in the given buffer";
	case WTE_DUPENT: return "Entity duplication detected";
	case WTE_REFER:  return "Reference counter is non-zero";
	case WTE_BINERR: return "General binary error";
	case WTE_BADVER: return "Bad binary version or unsupported feature";
	case WTE_UNRES:  return "Unresolved external symbol";
	case WTE_AMBIG:  return "Ambiguous symbol";
	case WTE_BADEX:  return "Bad external";
	case WTE_URTEX:  return "Unhandled runtime exception";
	case WTE_INVOKE: return "Failed to invoke main{} block or function";
	case WTE_INTEG:  return "Integrity check failed";
	case WTE_MEMSZ:  return "Specified memory is too small";
	case WTE_REFCTX: return "Number of context references is non-zero";
	case WTE_BADCTX: return "Context in bad state";
	case WTE_NOSTK:  return "Stack is too small";
	case WTE_DESTRP: return "Program destructor invoked";
	case WTE_UCLEAN: return "Structure needs cleaning";
	default:         return NULL;
	}
}
